#include <stdio.h>

int A[3001][3001];
int N;
int K;
int b;
int seed;
int M=0;
int Type;

FILE *fpi,*fpo;

main(int argc, char *argv[]) {
	int i,j,k;
	int rotate;
	int tmp;

	if (argc != 3) {
		printf("Usage: Commandname <inputfile> <outputfile>\n");
		exit(0);
	}
	fpi = fopen(argv[1],"r");
	fpo = fopen(argv[2],"w");


	fscanf(fpi,"%d %d %d %d %d", &Type, &N, &K, &b,&seed);
	srandom(seed);

	for (i=1;i<=N;i++) 
		for (j=1;j<=N;j++) {
			A[i][j]=A[j][i]=0;
		}

	/* Method 1; Generate random graphs with b-1:1 ratio for the
	   absence of any edge */
	if (Type==1)
	{
	M=0;

	for (i=1;i<=N;i++) {
		for (j=i+1;j<=N;j++) {
			k=random()%b;
			if (k>0) k=0;
			else k=1;
			if ((A[i][j]==0) && (k>0)) M++;
			A[i][j]=k;
			A[j][i]=k;
		}
	}
	}

	/* Method 2; takes N, K, b, seed
	 * sets up a subgraph of size b with at least degree K
	 * within the subgraph. adds the other N-L vertices in
	 * such a way that all of them fall off */
	 else
	 {
         M=0;
	 
         for (i=1;i<=b;i++) {
		 for (j=1;j<=K;j++) {
			 if (A[i][(((i-1)+j)%b)+1]!=1) 
				 M++;
			 A[i][(((i-1)+j)%b)+1]=1;
			 A[(((i-1)+j)%b)+1][i]=1;
		 }
	 }
	 //printf("%d\n",M);

	 for (i=b+1;i<=N-b;i++) {
		 for (j=1;j<=K-1;j++) { 
			 A[i][i-j]=A[i-j][i]=1;
			 M++;
		 }
	 }
	 //printf("%d\n",M);

	 tmp=N-b+1;
	 if (b+1 > N-b+1) tmp=b+1;

	 for (i=tmp;i<=N-1;i++) {
		 for (j=2;j<=K;j++) { 
			 A[i][i-j]=A[i-j][i]=1;
			 M++;
		 }
	 }
	 //printf("%d\n",M);
	 for (j=N-1;j>=N-K+1;j--) {
		 A[N][j]=A[j][N]=1;
		 M++;
	 }
	 //printf("%d\n",M);
	        
	 }

	fprintf(fpo,"%d %d %d\n",N,M,K);
	rotate=random()%N;
	for (i=1;i<=N;i++)
		for (j=i+1;j<=N;j++)
		{
			if (A[((i-1)+rotate)%N+1][((j-1)+rotate)%N+1]==1)
				fprintf(fpo,"%d %d\n",i,j);

//			if (A[i][j]) printf("%d %d\n",i,j);
		}


}
